[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.62 and 1.74

version 1.62, 2021/12/09 02:17:41 version 1.74, 2021/12/11 20:57:51
Line 32 
Line 32 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
Line 48 
Line 50 
         echo "$_dir"          echo "$_dir"
 }  }
   
 realpath () {  
         if [ -x /usr/bin/realpath ]; then  
                 /usr/bin/realpath "$1"  
         elif [ "$1" = "${1%/*}" ]; then  
                 echo "${PWD}/$1"  
         else  
                 echo "$( cd "${1%/*}" && pwd )/${1##*/}"  
         fi  
 }  
   
 fetch() {  fetch() {
         local _file=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
   
         >"$_file"  
         chown "$_user" "$_file"  
   
         # If we're not in the installer, we have su(1)          # If we're not in the installer, we have su(1)
         # and doas(1) is unlikely to be configured.          # and doas(1) is unlikely to be configured.
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm \                      "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                         -o '$_file' '${FWURL}/${_file}'"  
                 _exit="$?"                  _exit="$?"
         else          else
                 /usr/bin/doas -u "$_user" \                  /usr/bin/doas -u "$_user" \
                     ftp -D 'Get/Verify' -Vm \                      /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                         -o "$_file" "${FWURL}/${_file}"  
                 _exit="$?"                  _exit="$?"
         fi          fi
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_file"                  rm -f "$_dst"
                 echo "Cannot fetch $_file" >&2                  echo "Cannot fetch $_src" >&2
                 return 1                  return 1
         fi          fi
   
         chown root "$_file"  
 }  }
   
 verify() {  verify() {
         # On the installer we don't get sha256 -C, so fake it.          # On the installer we don't get sha256 -C, so fake it.
         if ! fgrep -qx "SHA256 ($1) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                 echo "Checksum test for $1 failed." >&2                  echo "Checksum test for ${1##*/} failed." >&2
                 return 1                  return 1
         fi          fi
 }  }
Line 136 
Line 121 
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}"
           local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
         ftp -D "Install" -Vmo- "file:${1}" |          ftp -D "Install" -Vmo- "file:${1}" |
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                  tar -s ",^\+,${_pkgdir}/+," \
                 -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                 -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 187 
Line 173 
 }  }
   
 usage() {  usage() {
         echo "Usage: fw_install [ -d dir ] [ driver | file [ ... ] ]"          echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
         exit 2          exit 2
 }  }
   
 DOWNLOADDIR=  INSTALL=true
 while getopts d: name  DOWNLOAD=true
   
   while getopts dL name
 do  do
        case "$name" in         case "$name" in
        d) DOWNLOADDIR=$OPTARG ;;         # "download only" means local dir and don't install
          d) LOCALSRC=. INSTALL=false ;;
          L) LOCALSRC=. ;;
        ?) usage 2 ;;         ?) usage 2 ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
   # If we're installing from a local dir
   # we don't want to download anything
   [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
   [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 [ "${devices[*]:-}" ] ||  [ "${devices[*]:-}" ] ||
     set -A devices -- $( devices_needing_firmware )      set -A devices -- $( devices_needing_firmware )
   
 if [ ! "${devices:-}" ]; then  if [ ! "${devices[*]:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo "No devices found which need firmware files to be downloaded."
         exit          exit
 fi  fi
   
 # Have to find the full path to firmware files  if "$DOWNLOAD"; then
 # so we can cd and still find them later.          fetch "$CFILE"
 i=0          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
 while (( i < "${#devices[@]}" )); do              echo "Signature check of SHA256.sig failed" >&2 && exit 1
         f="${devices[$i]}"  
         d=$( firmware_devicename "$f" )  
         [ "$f" = "$d" ] && f="$( echo "$f"-firmware-*.tgz | sed '$!d' )"  
         if [ -e "$f" ]; then  
                 if [ "${DOWNLOADDIR:-}" ]; then  
                         echo "Cannot download local file $f" >&2  
                         exit 2  
                 fi  
                 devices[$i]="$d:$( realpath "$f" )"  
         fi  
         i=$((i + 1))  
 done  
   
 if [ "$DOWNLOADDIR" ]; then  
         if ! cd "$DOWNLOADDIR"; then  
                 echo "Unable to use $DOWNLOADDIR, make sure it is a directory"  
                 exit 2  
         fi  
 else  
         TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )  
         cd "$TMPDIR"  
 fi  fi
   
 # To unpriv we need to let the unpriv user into this dir  for f in "${devices[@]}"; do
 chmod go+x .          d="$( firmware_devicename "$f" )"
   
 fetch "$CFILE"  
 ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&  
     echo "Signature check of SHA256.sig failed" >&2 && exit 1  
   
 for d in "${devices[@]}"; do  
         f="${d##*:}"  
         if [ "$f" = "$d" ]; then          if [ "$f" = "$d" ]; then
                 f=$( firmware_filename "$d" || true )                  f=$( firmware_filename "$d" || true )
                 [ "$f" ] || continue                  [ "$f" ] || continue
         else                  f="$LOCALSRC/$f"
                 d="${d%:*}"          elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
         fi          fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware "$d" )
   
         if [ ! "${DOWNLOADDIR:-}" ] && [ "${installed:-}" ]; then          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]:-}"; do                  for i in "${installed[@]}"; do
                         if [ "${f##*/}" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  echo "$i already installed"
                                 continue 2                                  continue 2
Line 265 
Line 235 
                 done                  done
         fi          fi
   
         if [ ! -e "$f" ]; then          if [ -e "$f" ]; then
                   if "$DOWNLOAD"; then
                           echo "Verify existing ${f##*/}"
                           verify "$f" || continue
                   # else assume it was verified when downloaded
                   fi
           elif "$INSTALL" && ! "$DOWNLOAD"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           else
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
         elif [ "${DOWNLOADDIR:-}" ]; then  
                 echo "Already have $f"  
                 verify "$f" || continue  
         fi          fi
   
         [ "${DOWNLOADDIR:-}" ] && continue          "$INSTALL" || continue
   
         if [ "${installed:-}" ]; then          if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          delete_firmware "$i"
                 done                  done

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.74

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>